"use strict";
this.name        = "tugdrone";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Tug Drone can tow instead of you.";
this.version     = "0.9";

this.$TugDrone_Distance = 0;
this.$TugDrone_Timer = null;
this.$TugDrone_Target = null;


this.playAbortSound = function() {
    var TugDrone_Sound = new SoundSource;
    TugDrone_Sound.sound = "witchabort.ogg"; //sound if cannot start
    TugDrone_Sound.loop = false;
    TugDrone_Sound.repeatCount = 1;
    TugDrone_Sound.play();
}

this.shipCollided = function(otherShip) {
    if( this.$TugDrone_Target && this.$TugDrone_Target.isValid
         && otherShip == this.$TugDrone_Target )
        this.$TugDrone_Hit(); //payout
}

this.entityDestroyed = function() {
    if( this.$TugDrone_Timer ) {
        this.$TugDrone_Timer.stop();
        delete this.$TugDrone_Timer;
    }
    if( this.$TugDrone_Target && this.$TugDrone_Target.isValid
        && this.$TugDrone_Distance < 300 ) //need saved distance due to this.ship is invalid when destroyed
        this.$TugDrone_Hit(); //within 300m assuming to hit the target, go to payout
}

this.shipSpawned = function() {
    var ship = player.ship.target;
    if( !ship ) {
        player.ship.awardEquipment("EQ_TUGDRONE_MISSILE");
        player.consoleMessage("Tug Drone cannot start: need more exact aim",5);
        this.ship.remove(true); //remove drone
        this.playAbortSound();
//        log("TugDrone", "No target");
    } else if( ship.isValid && ship.isDerelict &&
        player.ship.position.distanceTo( ship.position ) < player.ship.scannerRange ) {
        this.$TugDrone_Timer = new Timer(this, this.$TugDrone_Timed, 0, 0.25);//distance meter
        player.consoleMessage("Tug Drone launched.",3);
        this.$TugDrone_Target = ship;
//        log("TugDrone", "Launched to "+ship.displayName+" "+ship);
    } else {
        player.ship.awardEquipment("EQ_TUGDRONE_MISSILE");
        player.consoleMessage("Tug Drone cannot start: need derelict ship in scanner range",5);
        this.ship.remove(true); //remove drone
        this.playAbortSound();
//        log("TugDrone", "Not launched to "+ship);
    }
}

this.$TugDrone_Hit = function() {
    var ship = this.$TugDrone_Target;

    if( this.$TugDrone_Timer ) {
        this.$TugDrone_Timer.stop();
        delete this.$TugDrone_Timer;
    }
    if( ship && ship.isValid && ship.isDerelict ) {
        log("TugDrone", "Payout for "+ship.displayName+" "+ship);
        this.ship.remove(true); //remove drone
        worldScripts["towbar"].$Towbar_Bounty( ship ); //if a missile hit the player after eject
        worldScripts["towbar"].$Towbar_Payout( ship ); //will remove the target ship
    }
}

this.$TugDrone_Timed = function() { //distance meter
    if( this.$TugDrone_Target && this.$TugDrone_Target.isValid && this.ship && this.ship.isValid ) {//save distance
        this.$TugDrone_Distance = this.ship.position.distanceTo( this.$TugDrone_Target.position );
//        log("TugDrone", this.$TugDrone_Distance+"m from target: "+ship);
    }
}
